// This file was generated by gir (https://github.com/gtk-rs/gir)
// from gir-files (https://github.com/gtk-rs/gir-files)
// from gst-gir-files (https://gitlab.freedesktop.org/gstreamer/gir-files-rs.git)
// DO NOT EDIT

use crate::DiscovererInfo;
use glib::object::IsA;
use glib::translate::*;

glib::wrapper! {
    pub struct EncodingProfile(Object<ffi::GstEncodingProfile, ffi::GstEncodingProfileClass>);

    match fn {
        type_ => || ffi::gst_encoding_profile_get_type(),
    }
}

impl EncodingProfile {
    #[doc(alias = "gst_encoding_profile_find")]
    pub fn find(
        targetname: &str,
        profilename: Option<&str>,
        category: Option<&str>,
    ) -> Option<EncodingProfile> {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_full(ffi::gst_encoding_profile_find(
                targetname.to_glib_none().0,
                profilename.to_glib_none().0,
                category.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "gst_encoding_profile_from_discoverer")]
    pub fn from_discoverer(info: &DiscovererInfo) -> Result<EncodingProfile, glib::BoolError> {
        skip_assert_initialized!();
        unsafe {
            Option::<_>::from_glib_full(ffi::gst_encoding_profile_from_discoverer(
                info.to_glib_none().0,
            ))
            .ok_or_else(|| {
                glib::bool_error!("Failed to create EncodingProfile from DiscovererInfo")
            })
        }
    }
}

unsafe impl Send for EncodingProfile {}
unsafe impl Sync for EncodingProfile {}

pub const NONE_ENCODING_PROFILE: Option<&EncodingProfile> = None;

pub trait EncodingProfileExt: 'static {
    #[cfg(any(feature = "v1_12", feature = "dox"))]
    #[cfg_attr(feature = "dox", doc(cfg(feature = "v1_12")))]
    #[doc(alias = "gst_encoding_profile_copy")]
    fn copy(&self) -> EncodingProfile;

    #[doc(alias = "gst_encoding_profile_get_allow_dynamic_output")]
    fn allows_dynamic_output(&self) -> bool;

    #[doc(alias = "gst_encoding_profile_get_description")]
    fn description(&self) -> Option<glib::GString>;

    #[doc(alias = "gst_encoding_profile_get_file_extension")]
    fn file_extension(&self) -> Option<glib::GString>;

    #[doc(alias = "gst_encoding_profile_get_format")]
    fn format(&self) -> gst::Caps;

    #[doc(alias = "gst_encoding_profile_get_input_caps")]
    fn input_caps(&self) -> gst::Caps;

    #[doc(alias = "gst_encoding_profile_get_name")]
    fn name(&self) -> Option<glib::GString>;

    #[doc(alias = "gst_encoding_profile_get_presence")]
    fn presence(&self) -> u32;

    #[doc(alias = "gst_encoding_profile_get_preset")]
    fn preset(&self) -> Option<glib::GString>;

    #[doc(alias = "gst_encoding_profile_get_preset_name")]
    fn preset_name(&self) -> Option<glib::GString>;

    #[cfg(any(feature = "v1_18", feature = "dox"))]
    #[cfg_attr(feature = "dox", doc(cfg(feature = "v1_18")))]
    #[doc(alias = "gst_encoding_profile_get_single_segment")]
    fn is_single_segment(&self) -> bool;

    #[doc(alias = "gst_encoding_profile_get_type_nick")]
    fn type_nick(&self) -> Option<glib::GString>;

    #[doc(alias = "gst_encoding_profile_is_enabled")]
    fn is_enabled(&self) -> bool;

    #[doc(alias = "gst_encoding_profile_is_equal")]
    fn is_equal<P: IsA<EncodingProfile>>(&self, b: &P) -> bool;
}

impl<O: IsA<EncodingProfile>> EncodingProfileExt for O {
    #[cfg(any(feature = "v1_12", feature = "dox"))]
    #[cfg_attr(feature = "dox", doc(cfg(feature = "v1_12")))]
    fn copy(&self) -> EncodingProfile {
        unsafe {
            from_glib_full(ffi::gst_encoding_profile_copy(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn allows_dynamic_output(&self) -> bool {
        unsafe {
            from_glib(ffi::gst_encoding_profile_get_allow_dynamic_output(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn description(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::gst_encoding_profile_get_description(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn file_extension(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::gst_encoding_profile_get_file_extension(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn format(&self) -> gst::Caps {
        unsafe {
            from_glib_full(ffi::gst_encoding_profile_get_format(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn input_caps(&self) -> gst::Caps {
        unsafe {
            from_glib_full(ffi::gst_encoding_profile_get_input_caps(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn name(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::gst_encoding_profile_get_name(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn presence(&self) -> u32 {
        unsafe { ffi::gst_encoding_profile_get_presence(self.as_ref().to_glib_none().0) }
    }

    fn preset(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::gst_encoding_profile_get_preset(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn preset_name(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::gst_encoding_profile_get_preset_name(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[cfg(any(feature = "v1_18", feature = "dox"))]
    #[cfg_attr(feature = "dox", doc(cfg(feature = "v1_18")))]
    fn is_single_segment(&self) -> bool {
        unsafe {
            from_glib(ffi::gst_encoding_profile_get_single_segment(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn type_nick(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::gst_encoding_profile_get_type_nick(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn is_enabled(&self) -> bool {
        unsafe {
            from_glib(ffi::gst_encoding_profile_is_enabled(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn is_equal<P: IsA<EncodingProfile>>(&self, b: &P) -> bool {
        unsafe {
            from_glib(ffi::gst_encoding_profile_is_equal(
                self.as_ref().to_glib_none().0,
                b.as_ref().to_glib_none().0,
            ))
        }
    }
}
